   1 typedef enum {
   2       Iop_INVALID=0x1400,
   3       Iop_Add8,  Iop_Add16,  Iop_Add32,  Iop_Add64,
   4       Iop_Sub8,  Iop_Sub16,  Iop_Sub32,  Iop_Sub64,
   5       /* Signless mul.  MullS/MullU is elsewhere. */
   6       Iop_Mul8,  Iop_Mul16,  Iop_Mul32,  Iop_Mul64,
   7       Iop_Or8,   Iop_Or16,   Iop_Or32,   Iop_Or64,
   8       Iop_And8,  Iop_And16,  Iop_And32,  Iop_And64,
   9       Iop_Xor8,  Iop_Xor16,  Iop_Xor32,  Iop_Xor64,
  10       Iop_Shl8,  Iop_Shl16,  Iop_Shl32,  Iop_Shl64,
  11       Iop_Shr8,  Iop_Shr16,  Iop_Shr32,  Iop_Shr64,
  12       Iop_Sar8,  Iop_Sar16,  Iop_Sar32,  Iop_Sar64,
  13       /* Integer comparisons. */
  14       Iop_CmpEQ8,  Iop_CmpEQ16,  Iop_CmpEQ32,  Iop_CmpEQ64,
  15       Iop_CmpNE8,  Iop_CmpNE16,  Iop_CmpNE32,  Iop_CmpNE64,
  16       /* Tags for unary ops */
  17       Iop_Not8,  Iop_Not16,  Iop_Not32,  Iop_Not64,
  18       Iop_CasCmpEQ8, Iop_CasCmpEQ16, Iop_CasCmpEQ32, Iop_CasCmpEQ64,
  19       Iop_CasCmpNE8, Iop_CasCmpNE16, Iop_CasCmpNE32, Iop_CasCmpNE64,
  20       Iop_ExpCmpNE8, Iop_ExpCmpNE16, Iop_ExpCmpNE32, Iop_ExpCmpNE64,
  21       /* Widening multiplies */
  22       Iop_MullS8, Iop_MullS16, Iop_MullS32, Iop_MullS64,
  23       Iop_MullU8, Iop_MullU16, Iop_MullU32, Iop_MullU64,
  24       /* Wierdo integer stuff */
  25       Iop_Clz64, Iop_Clz32,   /* count leading zeroes */
  26       Iop_Ctz64, Iop_Ctz32,   /* count trailing zeros */
  27       /* Standard integer comparisons */
  28       Iop_CmpLT32S, Iop_CmpLT64S,
  29       Iop_CmpLE32S, Iop_CmpLE64S,
  30       Iop_CmpLT32U, Iop_CmpLT64U,
  31       Iop_CmpLE32U, Iop_CmpLE64U,
  32       /* As a sop to Valgrind-Memcheck, the following are useful. */
  33       Iop_CmpNEZ8, Iop_CmpNEZ16,  Iop_CmpNEZ32,  Iop_CmpNEZ64,
  34       Iop_CmpwNEZ32, Iop_CmpwNEZ64, /* all-0s -> all-Os; other -> all-1s */
  35       Iop_Left8, Iop_Left16, Iop_Left32, Iop_Left64, /*  \x -> x | -x */
  36       Iop_Max32U, /* unsigned max */
  37       Iop_CmpORD32U, Iop_CmpORD64U,
  38       Iop_CmpORD32S, Iop_CmpORD64S,
  39       /* Division */
  40       Iop_DivU32,   // :: I32,I32 -> I32 (simple div, no mod)
  41       Iop_DivS32,   // ditto, signed
  42       Iop_DivU64,   // :: I64,I64 -> I64 (simple div, no mod)
  43       Iop_DivS64,   // ditto, signed
  44       Iop_DivU64E,  // :: I64,I64 -> I64 (dividend is 64-bit arg (hi) concat with 64 0's (low))
  45       Iop_DivS64E,  // ditto, signed
  46       Iop_DivU32E,  // :: I32,I32 -> I32 (dividend is 32-bit arg (hi) concat with 32 0's (low))
  47       Iop_DivS32E,  // ditto, signed
  48       Iop_DivModU64to32, // :: I64,I32 -> I64
  49       Iop_DivModS64to32, // ditto, signed
  50       Iop_DivModU128to64, // :: V128,I64 -> V128
  51       Iop_DivModS128to64, // ditto, signed
  52       Iop_DivModS64to64, // :: I64,I64 -> I128
  53       /* Integer conversions. */
  54       /* Widening conversions */
  55       Iop_8Uto16, Iop_8Uto32,  Iop_8Uto64,
  56                   Iop_16Uto32, Iop_16Uto64,
  57                                Iop_32Uto64,
  58       Iop_8Sto16, Iop_8Sto32,  Iop_8Sto64,
  59                   Iop_16Sto32, Iop_16Sto64,
  60                                Iop_32Sto64,
  61       /* Narrowing conversions */
  62       Iop_64to8, Iop_32to8, Iop_64to16,
  63       /* 8 <-> 16 bit conversions */
  64       Iop_16to8,      // :: I16 -> I8, low half
  65       Iop_16HIto8,    // :: I16 -> I8, high half
  66       Iop_8HLto16,    // :: (I8,I8) -> I16
  67       /* 16 <-> 32 bit conversions */
  68       Iop_32to16,     // :: I32 -> I16, low half
  69       Iop_32HIto16,   // :: I32 -> I16, high half
  70       Iop_16HLto32,   // :: (I16,I16) -> I32
  71       /* 32 <-> 64 bit conversions */
  72       Iop_64to32,     // :: I64 -> I32, low half
  73       Iop_64HIto32,   // :: I64 -> I32, high half
  74       Iop_32HLto64,   // :: (I32,I32) -> I64
  75       /* 64 <-> 128 bit conversions */
  76       Iop_128to64,    // :: I128 -> I64, low half
  77       Iop_128HIto64,  // :: I128 -> I64, high half
  78       Iop_64HLto128,  // :: (I64,I64) -> I128
  79       /* 1-bit stuff */
  80       Iop_Not1,   /* :: Ity_Bit -> Ity_Bit */
  81       Iop_32to1,  /* :: Ity_I32 -> Ity_Bit, just select bit[0] */
  82       Iop_64to1,  /* :: Ity_I64 -> Ity_Bit, just select bit[0] */
  83       Iop_1Uto8,  /* :: Ity_Bit -> Ity_I8,  unsigned widen */
  84       Iop_1Uto32, /* :: Ity_Bit -> Ity_I32, unsigned widen */
  85       Iop_1Uto64, /* :: Ity_Bit -> Ity_I64, unsigned widen */
  86       Iop_1Sto8,  /* :: Ity_Bit -> Ity_I8,  signed widen */
  87       Iop_1Sto16, /* :: Ity_Bit -> Ity_I16, signed widen */
  88       Iop_1Sto32, /* :: Ity_Bit -> Ity_I32, signed widen */
  89       Iop_1Sto64, /* :: Ity_Bit -> Ity_I64, signed widen */
  90       /* ------ Floating point.  We try to be IEEE754 compliant. ------ */
  91       /* Binary operations, with rounding. */
  92       /* :: IRRoundingMode(I32) x F64 x F64 -> F64 */
  93       Iop_AddF64, Iop_SubF64, Iop_MulF64, Iop_DivF64,
  94       /* :: IRRoundingMode(I32) x F32 x F32 -> F32 */ 
  95       Iop_AddF32, Iop_SubF32, Iop_MulF32, Iop_DivF32,
  96       /* :: IRRoundingMode(I32) x F64 x F64 -> F64 */
  97       Iop_AddF64r32, Iop_SubF64r32, Iop_MulF64r32, Iop_DivF64r32,
  98       /* Unary operations, without rounding. */
  99       Iop_NegF64, Iop_AbsF64,
 100       Iop_NegF32, Iop_AbsF32,
 101       /* Unary operations, with rounding. */
 102       /* :: IRRoundingMode(I32) x F64 -> F64 */
 103       Iop_SqrtF64,
 104       /* :: IRRoundingMode(I32) x F32 -> F32 */
 105       Iop_SqrtF32,
 106       /* :: F64 x F64 -> IRCmpF64Result(I32) */
 107       Iop_CmpF64,
 108       Iop_CmpF32,
 109       Iop_CmpF128,
 110       /* --- Int to/from FP conversions. --- */
 111       Iop_F64toI16S, /* IRRoundingMode(I32) x F64 -> signed I16 */
 112       Iop_F64toI32S, /* IRRoundingMode(I32) x F64 -> signed I32 */
 113       Iop_F64toI64S, /* IRRoundingMode(I32) x F64 -> signed I64 */
 114       Iop_F64toI64U, /* IRRoundingMode(I32) x F64 -> unsigned I64 */
 115       Iop_F64toI32U, /* IRRoundingMode(I32) x F64 -> unsigned I32 */
 116       Iop_I32StoF64, /*                       signed I32 -> F64 */
 117       Iop_I64StoF64, /* IRRoundingMode(I32) x signed I64 -> F64 */
 118       Iop_I64UtoF64, /* IRRoundingMode(I32) x unsigned I64 -> F64 */
 119       Iop_I64UtoF32, /* IRRoundingMode(I32) x unsigned I64 -> F32 */
 120       Iop_I32UtoF32, /* IRRoundingMode(I32) x unsigned I32 -> F32 */
 121       Iop_I32UtoF64, /*                       unsigned I32 -> F64 */
 122       Iop_F32toI32S, /* IRRoundingMode(I32) x F32 -> signed I32 */
 123       Iop_F32toI64S, /* IRRoundingMode(I32) x F32 -> signed I64 */
 124       Iop_F32toI32U, /* IRRoundingMode(I32) x F32 -> unsigned I32 */
 125       Iop_F32toI64U, /* IRRoundingMode(I32) x F32 -> unsigned I64 */
 126       Iop_I32StoF32, /* IRRoundingMode(I32) x signed I32 -> F32 */
 127       Iop_I64StoF32, /* IRRoundingMode(I32) x signed I64 -> F32 */
 128       /* Conversion between floating point formats */
 129       Iop_F32toF64,  /*                       F32 -> F64 */
 130       Iop_F64toF32,  /* IRRoundingMode(I32) x F64 -> F32 */
 131       /* Reinterpretation. */
 132       Iop_ReinterpF64asI64, Iop_ReinterpI64asF64,
 133       Iop_ReinterpF32asI32, Iop_ReinterpI32asF32,
 134       /* Support for 128-bit floating point */
 135       Iop_F64HLtoF128,/* (high half of F128,low half of F128) -> F128 */
 136       Iop_F128HItoF64,/* F128 -> high half of F128 into a F64 register */
 137       Iop_F128LOtoF64,/* F128 -> low  half of F128 into a F64 register */
 138       /* :: IRRoundingMode(I32) x F128 x F128 -> F128 */
 139       Iop_AddF128, Iop_SubF128, Iop_MulF128, Iop_DivF128,
 140       /* :: F128 -> F128 */
 141       Iop_NegF128, Iop_AbsF128,
 142       /* :: IRRoundingMode(I32) x F128 -> F128 */
 143       Iop_SqrtF128,
 144       Iop_I32StoF128, /*                signed I32  -> F128 */
 145       Iop_I64StoF128, /*                signed I64  -> F128 */
 146       Iop_I32UtoF128, /*              unsigned I32  -> F128 */
 147       Iop_I64UtoF128, /*              unsigned I64  -> F128 */
 148       Iop_F32toF128,  /*                       F32  -> F128 */
 149       Iop_F64toF128,  /*                       F64  -> F128 */
 150       Iop_F128toI32S, /* IRRoundingMode(I32) x F128 -> signed I32  */
 151       Iop_F128toI64S, /* IRRoundingMode(I32) x F128 -> signed I64  */
 152       Iop_F128toI32U, /* IRRoundingMode(I32) x F128 -> unsigned I32  */
 153       Iop_F128toI64U, /* IRRoundingMode(I32) x F128 -> unsigned I64  */
 154       Iop_F128toF64,  /* IRRoundingMode(I32) x F128 -> F64         */
 155       Iop_F128toF32,  /* IRRoundingMode(I32) x F128 -> F32         */
 156       /* --- guest x86/amd64 specifics, not mandated by 754. --- */
 157       /* Binary ops, with rounding. */
 158       Iop_AtanF64,       /* FPATAN,  arctan(arg1/arg2)       */
 159       Iop_Yl2xF64,       /* FYL2X,   arg1 * log2(arg2)       */
 160       Iop_Yl2xp1F64,     /* FYL2XP1, arg1 * log2(arg2+1.0)   */
 161       Iop_PRemF64,       /* FPREM,   non-IEEE remainder(arg1/arg2)    */
 162       Iop_PRemC3210F64,  /* C3210 flags resulting from FPREM, :: I32 */
 163       Iop_PRem1F64,      /* FPREM1,  IEEE remainder(arg1/arg2)    */
 164       Iop_PRem1C3210F64, /* C3210 flags resulting from FPREM1, :: I32 */
 165       Iop_ScaleF64,      /* FSCALE,  arg1 * (2^RoundTowardsZero(arg2)) */
 166       /* Unary ops, with rounding. */
 167       /* :: IRRoundingMode(I32) x F64 -> F64 */
 168       Iop_SinF64,    /* FSIN */
 169       Iop_CosF64,    /* FCOS */
 170       Iop_TanF64,    /* FTAN */
 171       Iop_2xm1F64,   /* (2^arg - 1.0) */
 172       Iop_RoundF64toInt, /* F64 value to nearest integral value (still as F64) */
 173       Iop_RoundF32toInt, /* F32 value to nearest integral value (still as F32) */
 174       /* --- guest s390 specifics, not mandated by 754. --- */
 175       /* Fused multiply-add/sub */
 176       /* :: IRRoundingMode(I32) x F32 x F32 x F32 -> F32 (computes arg2 * arg3 +/- arg4) */ 
 177       Iop_MAddF32, Iop_MSubF32,
 178       /* --- guest ppc32/64 specifics, not mandated by 754. --- */
 179       /* Ternary operations, with rounding. */
 180       /* Fused multiply-add/sub, with 112-bit intermediate precision for ppc. */
 181       /* :: IRRoundingMode(I32) x F64 x F64 x F64 -> F64 */
 182       Iop_MAddF64, Iop_MSubF64,
 183       /* :: IRRoundingMode(I32) x F64 x F64 x F64 -> F64 */
 184       Iop_MAddF64r32, Iop_MSubF64r32,
 185       /* :: F64 -> F64 */
 186       Iop_Est5FRSqrt,    /* reciprocal square root estimate, 5 good bits */
 187       Iop_RoundF64toF64_NEAREST, /* frin */
 188       Iop_RoundF64toF64_NegINF,  /* frim */
 189       Iop_RoundF64toF64_PosINF,  /* frip */
 190       Iop_RoundF64toF64_ZERO,    /* friz */
 191       /* :: F64 -> F32 */
 192       Iop_TruncF64asF32, /* do F64->F32 truncation as per 'fsts' */
 193       /* :: IRRoundingMode(I32) x F64 -> F64 */
 194       Iop_RoundF64toF32, /* round F64 to nearest F32 value (still as F64) */
 195       /* ------------------ 32-bit SIMD Integer ------------------ */
 196       /* 32x1 saturating add/sub (ok, well, not really SIMD :) */
 197       Iop_QAdd32S,
 198       Iop_QSub32S,
 199       /* 16x2 add/sub, also signed/unsigned saturating variants */
 200       Iop_Add16x2, Iop_Sub16x2,
 201       Iop_QAdd16Sx2, Iop_QAdd16Ux2,
 202       Iop_QSub16Sx2, Iop_QSub16Ux2,
 203       /* 16x2 signed/unsigned halving add/sub.  For each lane, these */
 204       Iop_HAdd16Ux2, Iop_HAdd16Sx2,
 205       Iop_HSub16Ux2, Iop_HSub16Sx2,
 206       /* 8x4 add/sub, also signed/unsigned saturating variants */
 207       Iop_Add8x4, Iop_Sub8x4,
 208       Iop_QAdd8Sx4, Iop_QAdd8Ux4,
 209       Iop_QSub8Sx4, Iop_QSub8Ux4,
 210       /* 8x4 signed/unsigned halving add/sub.  For each lane, these */
 211       Iop_HAdd8Ux4, Iop_HAdd8Sx4,
 212       Iop_HSub8Ux4, Iop_HSub8Sx4,
 213       /* 8x4 sum of absolute unsigned differences. */
 214       Iop_Sad8Ux4,
 215       /* MISC (vector integer cmp != 0) */
 216       Iop_CmpNEZ16x2, Iop_CmpNEZ8x4,
 217       /* ------------------ 64-bit SIMD FP ------------------------ */
 218       /* Convertion to/from int */
 219       Iop_I32UtoFx2,  Iop_I32StoFx2,    /* I32x4 -> F32x4 */
 220       Iop_FtoI32Ux2_RZ,  Iop_FtoI32Sx2_RZ,    /* F32x4 -> I32x4 */
 221       Iop_F32ToFixed32Ux2_RZ, Iop_F32ToFixed32Sx2_RZ, /* fp -> fixed-point */
 222       Iop_Fixed32UToF32x2_RN, Iop_Fixed32SToF32x2_RN, /* fixed-point -> fp */
 223       /* Binary operations */
 224       Iop_Max32Fx2,      Iop_Min32Fx2,
 225       Iop_PwMax32Fx2,    Iop_PwMin32Fx2,
 226       Iop_CmpEQ32Fx2, Iop_CmpGT32Fx2, Iop_CmpGE32Fx2,
 227       /* Vector Reciprocal */
 228       Iop_Recip32Fx2,
 229       Iop_Recps32Fx2,
 230       Iop_Rsqrte32Fx2,
 231       Iop_Rsqrts32Fx2,
 232       /* Unary */
 233       Iop_Neg32Fx2, Iop_Abs32Fx2,
 234       /* ------------------ 64-bit SIMD Integer. ------------------ */
 235       /* MISC (vector integer cmp != 0) */
 236       Iop_CmpNEZ8x8, Iop_CmpNEZ16x4, Iop_CmpNEZ32x2,
 237       /* ADDITION (normal / unsigned sat / signed sat) */
 238       Iop_Add8x8,   Iop_Add16x4,   Iop_Add32x2,
 239       Iop_QAdd8Ux8, Iop_QAdd16Ux4, Iop_QAdd32Ux2, Iop_QAdd64Ux1,
 240       Iop_QAdd8Sx8, Iop_QAdd16Sx4, Iop_QAdd32Sx2, Iop_QAdd64Sx1,
 241       /* PAIRWISE operations */
 242       Iop_PwAdd8x8,  Iop_PwAdd16x4,  Iop_PwAdd32x2,
 243       Iop_PwMax8Sx8, Iop_PwMax16Sx4, Iop_PwMax32Sx2,
 244       Iop_PwMax8Ux8, Iop_PwMax16Ux4, Iop_PwMax32Ux2,
 245       Iop_PwMin8Sx8, Iop_PwMin16Sx4, Iop_PwMin32Sx2,
 246       Iop_PwMin8Ux8, Iop_PwMin16Ux4, Iop_PwMin32Ux2,
 247       /* Longening variant is unary. */
 248       Iop_PwAddL8Ux8, Iop_PwAddL16Ux4, Iop_PwAddL32Ux2,
 249       Iop_PwAddL8Sx8, Iop_PwAddL16Sx4, Iop_PwAddL32Sx2,
 250       /* SUBTRACTION (normal / unsigned sat / signed sat) */
 251       Iop_Sub8x8,   Iop_Sub16x4,   Iop_Sub32x2,
 252       Iop_QSub8Ux8, Iop_QSub16Ux4, Iop_QSub32Ux2, Iop_QSub64Ux1,
 253       Iop_QSub8Sx8, Iop_QSub16Sx4, Iop_QSub32Sx2, Iop_QSub64Sx1,
 254       /* ABSOLUTE VALUE */
 255       Iop_Abs8x8, Iop_Abs16x4, Iop_Abs32x2,
 256       /* MULTIPLICATION (normal / high half of signed/unsigned / plynomial ) */
 257       Iop_Mul8x8, Iop_Mul16x4, Iop_Mul32x2,
 258       Iop_Mul32Fx2,
 259       Iop_MulHi16Ux4,
 260       Iop_MulHi16Sx4,
 261       Iop_PolynomialMul8x8,
 262       /* Vector Saturating Doubling Multiply Returning High Half and */
 263       Iop_QDMulHi16Sx4, Iop_QDMulHi32Sx2,
 264       Iop_QRDMulHi16Sx4, Iop_QRDMulHi32Sx2,
 265       /* AVERAGING: note: (arg1 + arg2 + 1) >>u 1 */
 266       Iop_Avg8Ux8,
 267       Iop_Avg16Ux4,
 268       /* MIN/MAX */
 269       Iop_Max8Sx8, Iop_Max16Sx4, Iop_Max32Sx2,
 270       Iop_Max8Ux8, Iop_Max16Ux4, Iop_Max32Ux2,
 271       Iop_Min8Sx8, Iop_Min16Sx4, Iop_Min32Sx2,
 272       Iop_Min8Ux8, Iop_Min16Ux4, Iop_Min32Ux2,
 273       /* COMPARISON */
 274       Iop_CmpEQ8x8,  Iop_CmpEQ16x4,  Iop_CmpEQ32x2,
 275       Iop_CmpGT8Ux8, Iop_CmpGT16Ux4, Iop_CmpGT32Ux2,
 276       Iop_CmpGT8Sx8, Iop_CmpGT16Sx4, Iop_CmpGT32Sx2,
 277       /* COUNT ones / leading zeroes / leading sign bits (not including topmost bit) */
 278       Iop_Cnt8x8,
 279       Iop_Clz8Sx8, Iop_Clz16Sx4, Iop_Clz32Sx2,
 280       Iop_Cls8Sx8, Iop_Cls16Sx4, Iop_Cls32Sx2,
 281       Iop_Clz64x2,
 282       /* VECTOR x VECTOR SHIFT / ROTATE */
 283       Iop_Shl8x8, Iop_Shl16x4, Iop_Shl32x2,
 284       Iop_Shr8x8, Iop_Shr16x4, Iop_Shr32x2,
 285       Iop_Sar8x8, Iop_Sar16x4, Iop_Sar32x2,
 286       Iop_Sal8x8, Iop_Sal16x4, Iop_Sal32x2, Iop_Sal64x1,
 287       /* VECTOR x SCALAR SHIFT (shift amt :: Ity_I8) */
 288       Iop_ShlN8x8, Iop_ShlN16x4, Iop_ShlN32x2,
 289       Iop_ShrN8x8, Iop_ShrN16x4, Iop_ShrN32x2,
 290       Iop_SarN8x8, Iop_SarN16x4, Iop_SarN32x2,
 291       /* VECTOR x VECTOR SATURATING SHIFT */
 292       Iop_QShl8x8, Iop_QShl16x4, Iop_QShl32x2, Iop_QShl64x1,
 293       Iop_QSal8x8, Iop_QSal16x4, Iop_QSal32x2, Iop_QSal64x1,
 294       /* VECTOR x INTEGER SATURATING SHIFT */
 295       Iop_QShlN8Sx8, Iop_QShlN16Sx4, Iop_QShlN32Sx2, Iop_QShlN64Sx1,
 296       Iop_QShlN8x8, Iop_QShlN16x4, Iop_QShlN32x2, Iop_QShlN64x1,
 297       Iop_QSalN8x8, Iop_QSalN16x4, Iop_QSalN32x2, Iop_QSalN64x1,
 298       /* NARROWING (binary)  */
 299       Iop_QNarrowBin16Sto8Ux8,
 300       Iop_QNarrowBin16Sto8Sx8, Iop_QNarrowBin32Sto16Sx4,
 301       Iop_NarrowBin16to8x8,    Iop_NarrowBin32to16x4,
 302       /* INTERLEAVING */
 303       Iop_InterleaveHI8x8, Iop_InterleaveHI16x4, Iop_InterleaveHI32x2,
 304       Iop_InterleaveLO8x8, Iop_InterleaveLO16x4, Iop_InterleaveLO32x2,
 305       Iop_InterleaveOddLanes8x8, Iop_InterleaveEvenLanes8x8,
 306       Iop_InterleaveOddLanes16x4, Iop_InterleaveEvenLanes16x4,
 307       /* CONCATENATION -- build a new value by concatenating either */
 308       Iop_CatOddLanes8x8, Iop_CatOddLanes16x4,
 309       Iop_CatEvenLanes8x8, Iop_CatEvenLanes16x4,
 310       /* GET / SET elements of VECTOR */
 311       Iop_GetElem8x8, Iop_GetElem16x4, Iop_GetElem32x2,
 312       Iop_SetElem8x8, Iop_SetElem16x4, Iop_SetElem32x2,
 313       /* DUPLICATING -- copy value to all lanes */
 314       Iop_Dup8x8,   Iop_Dup16x4,   Iop_Dup32x2,
 315       /* EXTRACT -- copy 8-arg3 highest bytes from arg1 to 8-arg3 lowest bytes */
 316       Iop_Extract64,
 317       /* REVERSE the order of elements in each Half-words, Words, Double-words */
 318       Iop_Reverse16_8x8,
 319       Iop_Reverse32_8x8, Iop_Reverse32_16x4,
 320       Iop_Reverse64_8x8, Iop_Reverse64_16x4, Iop_Reverse64_32x2,
 321       /* PERMUTING -- copy src bytes to dst, */
 322       Iop_Perm8x8,
 323       /* MISC CONVERSION -- get high bits of each byte lane, a la x86/amd64 pmovmskb */
 324       Iop_GetMSBs8x8, /* I64 -> I8 */
 325       /* Vector Reciprocal Estimate and Vector Reciprocal Square Root Estimate */
 326       Iop_Recip32x2, Iop_Rsqrte32x2,
 327       /* ------------------ Decimal Floating Point ------------------ */
 328       /* ARITHMETIC INSTRUCTIONS   64-bit
 329 	 IRRoundingMode(I32) X D64 X D64 -> D64 */
 330       Iop_AddD64, Iop_SubD64, Iop_MulD64, Iop_DivD64,
 331       /* ARITHMETIC INSTRUCTIONS  128-bit
 332 	 IRRoundingMode(I32) X D128 X D128 -> D128 */
 333       Iop_AddD128, Iop_SubD128, Iop_MulD128, Iop_DivD128,
 334       /* SHIFT SIGNIFICAND INSTRUCTIONS */
 335       Iop_ShlD64, Iop_ShrD64,
 336       /* D128 x U8  -> D128  left shift and right shift respectively */
 337       Iop_ShlD128, Iop_ShrD128,
 338       /* FORMAT CONVERSION INSTRUCTIONS */
 339       Iop_D32toD64,
 340       /*   D64 -> D128 */
 341       Iop_D64toD128, 
 342       /*   I32S -> D128 */
 343       Iop_I32StoD128,
 344       /*   I32U -> D128 */
 345       Iop_I32UtoD128,
 346       /*   I64S -> D128 */
 347       Iop_I64StoD128, 
 348       /*   I64U -> D128 */
 349       Iop_I64UtoD128,
 350       Iop_D64toD32,
 351       Iop_D128toD64,
 352       Iop_I32StoD64,
 353       Iop_I32UtoD64,
 354       Iop_I64StoD64,
 355       Iop_I64UtoD64,
 356       Iop_D64toI32S,
 357       Iop_D64toI32U,
 358       Iop_D64toI64S,
 359       Iop_D64toI64U,
 360       Iop_D128toI32S,
 361       Iop_D128toI32U,
 362       Iop_D128toI64S,
 363       Iop_D128toI64U,
 364       Iop_F32toD32,
 365       Iop_F32toD64,
 366       Iop_F32toD128,
 367       Iop_F64toD32,
 368       Iop_F64toD64,
 369       Iop_F64toD128,
 370       Iop_F128toD32,
 371       Iop_F128toD64,
 372       Iop_F128toD128,
 373       Iop_D32toF32,
 374       Iop_D32toF64,
 375       Iop_D32toF128,
 376       Iop_D64toF32,
 377       Iop_D64toF64,
 378       Iop_D64toF128,
 379       Iop_D128toF32,
 380       Iop_D128toF64,
 381       Iop_D128toF128,
 382       /* ROUNDING INSTRUCTIONS */
 383       Iop_RoundD64toInt,
 384       Iop_RoundD128toInt,
 385       /* COMPARE INSTRUCTIONS */
 386       Iop_CmpD64,
 387       Iop_CmpD128,
 388       /* COMPARE BIASED EXPONENET INSTRUCTIONS */
 389       Iop_CmpExpD64,
 390       Iop_CmpExpD128,
 391       /* QUANTIZE AND ROUND INSTRUCTIONS */
 392       Iop_QuantizeD64,
 393       Iop_QuantizeD128,
 394       Iop_SignificanceRoundD64,
 395       Iop_SignificanceRoundD128,
 396       /* EXTRACT AND INSERT INSTRUCTIONS */
 397       Iop_ExtractExpD64,
 398       Iop_ExtractExpD128,
 399       Iop_ExtractSigD64,
 400       Iop_ExtractSigD128,
 401       Iop_InsertExpD64,
 402       Iop_InsertExpD128,
 403       Iop_D64HLtoD128, Iop_D128HItoD64, Iop_D128LOtoD64,
 404       Iop_DPBtoBCD,
 405       Iop_BCDtoDPB,
 406       /* BCD arithmetic instructions, (V128, V128) -> V128 */
 407       Iop_BCDAdd, Iop_BCDSub,
 408       Iop_ReinterpI64asD64,
 409       Iop_ReinterpD64asI64,
 410       /* ------------------ 128-bit SIMD FP. ------------------ */
 411       /* --- 32x4 vector FP --- */
 412       /* binary */
 413       Iop_Add32Fx4, Iop_Sub32Fx4, Iop_Mul32Fx4, Iop_Div32Fx4,
 414       Iop_Max32Fx4, Iop_Min32Fx4,
 415       Iop_Add32Fx2, Iop_Sub32Fx2,
 416       Iop_CmpEQ32Fx4, Iop_CmpLT32Fx4, Iop_CmpLE32Fx4, Iop_CmpUN32Fx4,
 417       Iop_CmpGT32Fx4, Iop_CmpGE32Fx4,
 418       /* Vector Absolute */
 419       Iop_Abs32Fx4,
 420       /* Pairwise Max and Min. See integer pairwise operations for details. */
 421       Iop_PwMax32Fx4, Iop_PwMin32Fx4,
 422       /* unary */
 423       Iop_Sqrt32Fx4, Iop_RSqrt32Fx4,
 424       Iop_Neg32Fx4,
 425       /* Vector Reciprocal */
 426       Iop_Recip32Fx4,
 427       Iop_Recps32Fx4,
 428       Iop_Rsqrte32Fx4,
 429       Iop_Rsqrts32Fx4,
 430       /* --- Int to/from FP conversion --- */
 431       Iop_I32UtoFx4,     Iop_I32StoFx4,       /* I32x4 -> F32x4       */
 432       Iop_FtoI32Ux4_RZ,  Iop_FtoI32Sx4_RZ,    /* F32x4 -> I32x4       */
 433       Iop_QFtoI32Ux4_RZ, Iop_QFtoI32Sx4_RZ,   /* F32x4 -> I32x4 (with saturation) */
 434       Iop_RoundF32x4_RM, Iop_RoundF32x4_RP,   /* round to fp integer  */
 435       Iop_RoundF32x4_RN, Iop_RoundF32x4_RZ,   /* round to fp integer  */
 436       Iop_F32ToFixed32Ux4_RZ, Iop_F32ToFixed32Sx4_RZ, /* fp -> fixed-point */
 437       Iop_Fixed32UToF32x4_RN, Iop_Fixed32SToF32x4_RN, /* fixed-point -> fp */
 438       /* --- Single to/from half conversion --- */
 439       Iop_F32toF16x4, Iop_F16toF32x4,         /* F32x4 <-> F16x4      */
 440       /* --- 32x4 lowest-lane-only scalar FP --- */
 441       /* binary */
 442       Iop_Add32F0x4, Iop_Sub32F0x4, Iop_Mul32F0x4, Iop_Div32F0x4,
 443       Iop_Max32F0x4, Iop_Min32F0x4,
 444       Iop_CmpEQ32F0x4, Iop_CmpLT32F0x4, Iop_CmpLE32F0x4, Iop_CmpUN32F0x4,
 445       /* unary */
 446       Iop_Recip32F0x4, Iop_Sqrt32F0x4, Iop_RSqrt32F0x4,
 447       /* --- 64x2 vector FP --- */
 448       /* binary */
 449       Iop_Add64Fx2, Iop_Sub64Fx2, Iop_Mul64Fx2, Iop_Div64Fx2,
 450       Iop_Max64Fx2, Iop_Min64Fx2,
 451       Iop_CmpEQ64Fx2, Iop_CmpLT64Fx2, Iop_CmpLE64Fx2, Iop_CmpUN64Fx2,
 452       /* unary */
 453       Iop_Recip64Fx2, Iop_Sqrt64Fx2, Iop_RSqrt64Fx2,
 454       /* --- 64x2 lowest-lane-only scalar FP --- */
 455       /* binary */
 456       Iop_Add64F0x2, Iop_Sub64F0x2, Iop_Mul64F0x2, Iop_Div64F0x2,
 457       Iop_Max64F0x2, Iop_Min64F0x2,
 458       Iop_CmpEQ64F0x2, Iop_CmpLT64F0x2, Iop_CmpLE64F0x2, Iop_CmpUN64F0x2,
 459       /* unary */
 460       Iop_Recip64F0x2, Iop_Sqrt64F0x2, Iop_RSqrt64F0x2,
 461       /* --- pack / unpack --- */
 462       /* 64 <-> 128 bit vector */
 463       Iop_V128to64,     // :: V128 -> I64, low half
 464       Iop_V128HIto64,   // :: V128 -> I64, high half
 465       Iop_64HLtoV128,   // :: (I64,I64) -> V128
 466       Iop_64UtoV128,
 467       Iop_SetV128lo64,
 468       /* 32 <-> 128 bit vector */
 469       Iop_32UtoV128,
 470       Iop_V128to32,     // :: V128 -> I32, lowest lane
 471       Iop_SetV128lo32,  // :: (V128,I32) -> V128
 472       /* ------------------ 128-bit SIMD Integer. ------------------ */
 473       /* BITWISE OPS */
 474       Iop_NotV128,
 475       Iop_AndV128, Iop_OrV128, Iop_XorV128,
 476       /* VECTOR SHIFT (shift amt :: Ity_I8) */
 477       Iop_ShlV128, Iop_ShrV128,
 478       /* MISC (vector integer cmp != 0) */
 479       Iop_CmpNEZ8x16, Iop_CmpNEZ16x8, Iop_CmpNEZ32x4, Iop_CmpNEZ64x2,
 480       /* ADDITION (normal / unsigned sat / signed sat) */
 481       Iop_Add8x16,   Iop_Add16x8,   Iop_Add32x4,  Iop_Add64x2,
 482       Iop_QAdd8Ux16, Iop_QAdd16Ux8, Iop_QAdd32Ux4, Iop_QAdd64Ux2,
 483       Iop_QAdd8Sx16, Iop_QAdd16Sx8, Iop_QAdd32Sx4, Iop_QAdd64Sx2,
 484       /* SUBTRACTION (normal / unsigned sat / signed sat) */
 485       Iop_Sub8x16,   Iop_Sub16x8,   Iop_Sub32x4,  Iop_Sub64x2,
 486       Iop_QSub8Ux16, Iop_QSub16Ux8, Iop_QSub32Ux4, Iop_QSub64Ux2,
 487       Iop_QSub8Sx16, Iop_QSub16Sx8, Iop_QSub32Sx4, Iop_QSub64Sx2,
 488       /* MULTIPLICATION (normal / high half of signed/unsigned) */
 489       Iop_Mul8x16,  Iop_Mul16x8,    Iop_Mul32x4,
 490       Iop_MulHi16Ux8, Iop_MulHi32Ux4,
 491       Iop_MulHi16Sx8, Iop_MulHi32Sx4,
 492       /* (widening signed/unsigned of even lanes, with lowest lane=zero) */
 493       Iop_MullEven8Ux16, Iop_MullEven16Ux8, Iop_MullEven32Ux4,
 494       Iop_MullEven8Sx16, Iop_MullEven16Sx8, Iop_MullEven32Sx4,
 495       /* FIXME: document these */
 496       Iop_Mull8Ux8, Iop_Mull8Sx8,
 497       Iop_Mull16Ux4, Iop_Mull16Sx4,
 498       Iop_Mull32Ux2, Iop_Mull32Sx2,
 499       /* Vector Saturating Doubling Multiply */
 500       Iop_QDMulHi16Sx8, Iop_QDMulHi32Sx4,
 501       Iop_QRDMulHi16Sx8, Iop_QRDMulHi32Sx4,
 502       /* Doubling saturating multiplication (long) (I64, I64) -> V128 */
 503       Iop_QDMulLong16Sx4, Iop_QDMulLong32Sx2,
 504       Iop_PolynomialMul8x16, /* (V128, V128) -> V128 */
 505       Iop_PolynomialMull8x8, /*   (I64, I64) -> V128 */
 506       /* Vector Polynomial multiplication add.   (V128, V128) -> V128 */
 507       Iop_PolynomialMulAdd8x16, Iop_PolynomialMulAdd16x8,
 508       Iop_PolynomialMulAdd32x4, Iop_PolynomialMulAdd64x2,
 509       /* PAIRWISE operations */
 510       Iop_PwAdd8x16, Iop_PwAdd16x8, Iop_PwAdd32x4,
 511       Iop_PwAdd32Fx2,
 512       /* Longening variant is unary. */
 513       Iop_PwAddL8Ux16, Iop_PwAddL16Ux8, Iop_PwAddL32Ux4,
 514       Iop_PwAddL8Sx16, Iop_PwAddL16Sx8, Iop_PwAddL32Sx4,
 515       /* Other unary pairwise ops */
 516       /* Vector bit matrix transpose.  (V128) -> V128 */
 517       Iop_PwBitMtxXpose64x2,
 518       /* ABSOLUTE VALUE */
 519       Iop_Abs8x16, Iop_Abs16x8, Iop_Abs32x4,
 520       /* AVERAGING: note: (arg1 + arg2 + 1) >>u 1 */
 521       Iop_Avg8Ux16, Iop_Avg16Ux8, Iop_Avg32Ux4,
 522       Iop_Avg8Sx16, Iop_Avg16Sx8, Iop_Avg32Sx4,
 523       /* MIN/MAX */
 524       Iop_Max8Sx16, Iop_Max16Sx8, Iop_Max32Sx4, Iop_Max64Sx2,
 525       Iop_Max8Ux16, Iop_Max16Ux8, Iop_Max32Ux4, Iop_Max64Ux2,
 526       Iop_Min8Sx16, Iop_Min16Sx8, Iop_Min32Sx4, Iop_Min64Sx2,
 527       Iop_Min8Ux16, Iop_Min16Ux8, Iop_Min32Ux4, Iop_Min64Ux2,
 528       /* COMPARISON */
 529       Iop_CmpEQ8x16,  Iop_CmpEQ16x8,  Iop_CmpEQ32x4,  Iop_CmpEQ64x2,
 530       Iop_CmpGT8Sx16, Iop_CmpGT16Sx8, Iop_CmpGT32Sx4, Iop_CmpGT64Sx2,
 531       Iop_CmpGT8Ux16, Iop_CmpGT16Ux8, Iop_CmpGT32Ux4, Iop_CmpGT64Ux2,
 532       /* COUNT ones / leading zeroes / leading sign bits (not including topmost bit) */
 533       Iop_Cnt8x16,
 534       Iop_Clz8Sx16, Iop_Clz16Sx8, Iop_Clz32Sx4,
 535       Iop_Cls8Sx16, Iop_Cls16Sx8, Iop_Cls32Sx4,
 536       /* VECTOR x SCALAR SHIFT (shift amt :: Ity_I8) */
 537       Iop_ShlN8x16, Iop_ShlN16x8, Iop_ShlN32x4, Iop_ShlN64x2,
 538       Iop_ShrN8x16, Iop_ShrN16x8, Iop_ShrN32x4, Iop_ShrN64x2,
 539       Iop_SarN8x16, Iop_SarN16x8, Iop_SarN32x4, Iop_SarN64x2,
 540       /* VECTOR x VECTOR SHIFT / ROTATE */
 541       Iop_Shl8x16, Iop_Shl16x8, Iop_Shl32x4, Iop_Shl64x2,
 542       Iop_Shr8x16, Iop_Shr16x8, Iop_Shr32x4, Iop_Shr64x2,
 543       Iop_Sar8x16, Iop_Sar16x8, Iop_Sar32x4, Iop_Sar64x2,
 544       Iop_Sal8x16, Iop_Sal16x8, Iop_Sal32x4, Iop_Sal64x2,
 545       Iop_Rol8x16, Iop_Rol16x8, Iop_Rol32x4, Iop_Rol64x2,
 546       /* VECTOR x VECTOR SATURATING SHIFT */
 547       Iop_QShl8x16, Iop_QShl16x8, Iop_QShl32x4, Iop_QShl64x2,
 548       Iop_QSal8x16, Iop_QSal16x8, Iop_QSal32x4, Iop_QSal64x2,
 549       /* VECTOR x INTEGER SATURATING SHIFT */
 550       Iop_QShlN8Sx16, Iop_QShlN16Sx8, Iop_QShlN32Sx4, Iop_QShlN64Sx2,
 551       Iop_QShlN8x16, Iop_QShlN16x8, Iop_QShlN32x4, Iop_QShlN64x2,
 552       Iop_QSalN8x16, Iop_QSalN16x8, Iop_QSalN32x4, Iop_QSalN64x2,
 553       /* NARROWING (binary) 
 554          -- narrow 2xV128 into 1xV128, hi half from left arg */
 555       Iop_QNarrowBin16Sto8Ux16, Iop_QNarrowBin32Sto16Ux8,
 556       Iop_QNarrowBin16Sto8Sx16, Iop_QNarrowBin32Sto16Sx8,
 557       Iop_QNarrowBin16Uto8Ux16, Iop_QNarrowBin32Uto16Ux8,
 558       Iop_NarrowBin16to8x16, Iop_NarrowBin32to16x8,
 559       Iop_QNarrowBin64Sto32Sx4, Iop_QNarrowBin64Uto32Ux4,
 560       Iop_NarrowBin64to32x4,
 561       /* NARROWING (unary) -- narrow V128 into I64 */
 562       Iop_NarrowUn16to8x8, Iop_NarrowUn32to16x4, Iop_NarrowUn64to32x2,
 563       /* Saturating narrowing from signed source to signed/unsigned destination */
 564       Iop_QNarrowUn16Sto8Sx8, Iop_QNarrowUn32Sto16Sx4, Iop_QNarrowUn64Sto32Sx2,
 565       Iop_QNarrowUn16Sto8Ux8, Iop_QNarrowUn32Sto16Ux4, Iop_QNarrowUn64Sto32Ux2,
 566       /* Saturating narrowing from unsigned source to unsigned destination */
 567       Iop_QNarrowUn16Uto8Ux8, Iop_QNarrowUn32Uto16Ux4, Iop_QNarrowUn64Uto32Ux2,
 568       /* WIDENING -- sign or zero extend each element of the argument */
 569       Iop_Widen8Uto16x8, Iop_Widen16Uto32x4, Iop_Widen32Uto64x2,
 570       Iop_Widen8Sto16x8, Iop_Widen16Sto32x4, Iop_Widen32Sto64x2,
 571       /* INTERLEAVING */
 572       Iop_InterleaveHI8x16, Iop_InterleaveHI16x8,
 573       Iop_InterleaveHI32x4, Iop_InterleaveHI64x2,
 574       Iop_InterleaveLO8x16, Iop_InterleaveLO16x8,
 575       Iop_InterleaveLO32x4, Iop_InterleaveLO64x2,
 576       /* Interleave odd/even lanes of operands.  Most-significant result lane */
 577       Iop_InterleaveOddLanes8x16, Iop_InterleaveEvenLanes8x16,
 578       Iop_InterleaveOddLanes16x8, Iop_InterleaveEvenLanes16x8,
 579       Iop_InterleaveOddLanes32x4, Iop_InterleaveEvenLanes32x4,
 580       /* CONCATENATION -- build a new value by concatenating either */
 581       Iop_CatOddLanes8x16, Iop_CatOddLanes16x8, Iop_CatOddLanes32x4,
 582       Iop_CatEvenLanes8x16, Iop_CatEvenLanes16x8, Iop_CatEvenLanes32x4,
 583       /* GET elements of VECTOR */
 584       Iop_GetElem8x16, Iop_GetElem16x8, Iop_GetElem32x4, Iop_GetElem64x2,
 585       /* DUPLICATING -- copy value to all lanes */
 586       Iop_Dup8x16, Iop_Dup16x8, Iop_Dup32x4,
 587       /* EXTRACT -- copy 16-arg3 highest bytes from arg1 to 16-arg3 lowest bytes */
 588       Iop_ExtractV128,
 589       /* REVERSE the order of elements in each Half-words, Words, */
 590       Iop_Reverse16_8x16,
 591       Iop_Reverse32_8x16, Iop_Reverse32_16x8,
 592       Iop_Reverse64_8x16, Iop_Reverse64_16x8, Iop_Reverse64_32x4,
 593       /* PERMUTING -- copy src bytes to dst, */
 594       Iop_Perm8x16,
 595       Iop_Perm32x4, /* ditto, except argR values are restricted to 0 .. 3 */
 596       /* MISC CONVERSION -- get high bits of each byte lane, a la */
 597       Iop_GetMSBs8x16, /* V128 -> I16 */
 598       /* Vector Reciprocal Estimate and Vector Reciprocal Square Root Estimate */
 599       Iop_Recip32x4, Iop_Rsqrte32x4,
 600       /* ------------------ 256-bit SIMD Integer. ------------------ */
 601       /* Pack/unpack */
 602       Iop_V256to64_0,  // V256 -> I64, extract least significant lane
 603       Iop_V256to64_1,
 604       Iop_V256to64_2,
 605       Iop_V256to64_3,  // V256 -> I64, extract most significant lane
 606       Iop_64x4toV256,  // (I64,I64,I64,I64)->V256
 607       Iop_V256toV128_0, // V256 -> V128, less significant lane
 608       Iop_V256toV128_1, // V256 -> V128, more significant lane
 609       Iop_V128HLtoV256, // (V128,V128)->V256, first arg is most signif
 610       Iop_AndV256,
 611       Iop_OrV256,
 612       Iop_XorV256,
 613       Iop_NotV256,
 614       /* MISC (vector integer cmp != 0) */
 615       Iop_CmpNEZ8x32, Iop_CmpNEZ16x16, Iop_CmpNEZ32x8, Iop_CmpNEZ64x4,
 616       Iop_Add8x32,    Iop_Add16x16,    Iop_Add32x8,    Iop_Add64x4,
 617       Iop_Sub8x32,    Iop_Sub16x16,    Iop_Sub32x8,    Iop_Sub64x4,
 618       Iop_CmpEQ8x32,  Iop_CmpEQ16x16,  Iop_CmpEQ32x8,  Iop_CmpEQ64x4,
 619       Iop_CmpGT8Sx32, Iop_CmpGT16Sx16, Iop_CmpGT32Sx8, Iop_CmpGT64Sx4,
 620       Iop_ShlN16x16, Iop_ShlN32x8, Iop_ShlN64x4,
 621       Iop_ShrN16x16, Iop_ShrN32x8, Iop_ShrN64x4,
 622       Iop_SarN16x16, Iop_SarN32x8,
 623       Iop_Max8Sx32, Iop_Max16Sx16, Iop_Max32Sx8,
 624       Iop_Max8Ux32, Iop_Max16Ux16, Iop_Max32Ux8,
 625       Iop_Min8Sx32, Iop_Min16Sx16, Iop_Min32Sx8,
 626       Iop_Min8Ux32, Iop_Min16Ux16, Iop_Min32Ux8,
 627       Iop_Mul16x16, Iop_Mul32x8,
 628       Iop_MulHi16Ux16, Iop_MulHi16Sx16,
 629       Iop_QAdd8Ux32, Iop_QAdd16Ux16,
 630       Iop_QAdd8Sx32, Iop_QAdd16Sx16,
 631       Iop_QSub8Ux32, Iop_QSub16Ux16,
 632       Iop_QSub8Sx32, Iop_QSub16Sx16,
 633       Iop_Avg8Ux32, Iop_Avg16Ux16,
 634       Iop_Perm32x8,
 635       /* (V128, V128) -> V128 */
 636       Iop_CipherV128, Iop_CipherLV128, Iop_CipherSV128,
 637       Iop_NCipherV128, Iop_NCipherLV128,
 638       /* Hash instructions, Federal Information Processing Standards */
 639       Iop_SHA512, Iop_SHA256,
 640       /* ------------------ 256-bit SIMD FP. ------------------ */
 641       Iop_Add64Fx4,
 642       Iop_Sub64Fx4,
 643       Iop_Mul64Fx4,
 644       Iop_Div64Fx4,
 645       Iop_Add32Fx8,
 646       Iop_Sub32Fx8,
 647       Iop_Mul32Fx8,
 648       Iop_Div32Fx8,
 649       Iop_Sqrt32Fx8,
 650       Iop_Sqrt64Fx4,
 651       Iop_RSqrt32Fx8,
 652       Iop_Recip32Fx8,
 653       Iop_Max32Fx8, Iop_Min32Fx8,
 654       Iop_Max64Fx4, Iop_Min64Fx4,
 655       Iop_LAST      /* must be the last enumerator */
 656    } IROp;

enum                    1
Iop_128HIto64          77
Iop_128to64            76
Iop_16HIto8            65
Iop_16HLto32           70
Iop_16Sto32            59
Iop_16Sto64            59
Iop_16to8              64
Iop_16Uto32            56
Iop_16Uto64            56
Iop_1Sto16             87
Iop_1Sto32             88
Iop_1Sto64             89
Iop_1Sto8              86
Iop_1Uto32             84
Iop_1Uto64             85
Iop_1Uto8              83
Iop_2xm1F64           171
Iop_32HIto16           69
Iop_32HLto64           74
Iop_32Sto64            60
Iop_32to1              81
Iop_32to16             68
Iop_32to8              62
Iop_32Uto64            57
Iop_32UtoV128         469
Iop_64HIto32           73
Iop_64HLto128          78
Iop_64HLtoV128        465
Iop_64to1              82
Iop_64to16             62
Iop_64to32             72
Iop_64to8              62
Iop_64UtoV128         466
Iop_64x4toV256        606
Iop_8HLto16            66
Iop_8Sto16             58
Iop_8Sto32             58
Iop_8Sto64             58
Iop_8Uto16             55
Iop_8Uto32             55
Iop_8Uto64             55
Iop_Abs16x4           255
Iop_Abs16x8           519
Iop_Abs32Fx2          233
Iop_Abs32Fx4          419
Iop_Abs32x2           255
Iop_Abs32x4           519
Iop_Abs8x16           519
Iop_Abs8x8            255
Iop_AbsF128           141
Iop_AbsF32            100
Iop_AbsF64             99
Iop_Add16               3
Iop_Add16x16          616
Iop_Add16x2           200
Iop_Add16x4           238
Iop_Add16x8           481
Iop_Add32               3
Iop_Add32F0x4         442
Iop_Add32Fx2          415
Iop_Add32Fx4          413
Iop_Add32Fx8          645
Iop_Add32x2           238
Iop_Add32x4           481
Iop_Add32x8           616
Iop_Add64               3
Iop_Add64F0x2         456
Iop_Add64Fx2          449
Iop_Add64Fx4          641
Iop_Add64x2           481
Iop_Add64x4           616
Iop_Add8                3
Iop_Add8x16           481
Iop_Add8x32           616
Iop_Add8x4            207
Iop_Add8x8            238
Iop_AddD128           333
Iop_AddD64            330
Iop_AddF128           139
Iop_AddF32             95
Iop_AddF64             93
Iop_AddF64r32          97
Iop_And16               8
Iop_And32               8
Iop_And64               8
Iop_And8                8
Iop_AndV128           475
Iop_AndV256           610
Iop_AtanF64           158
Iop_Avg16Sx8          522
Iop_Avg16Ux16         633
Iop_Avg16Ux4          267
Iop_Avg16Ux8          521
Iop_Avg32Sx4          522
Iop_Avg32Ux4          521
Iop_Avg8Sx16          522
Iop_Avg8Ux16          521
Iop_Avg8Ux32          633
Iop_Avg8Ux8           266
Iop_BCDAdd            407
Iop_BCDSub            407
Iop_BCDtoDPB          405
Iop_CasCmpEQ16         18
Iop_CasCmpEQ32         18
Iop_CasCmpEQ64         18
Iop_CasCmpEQ8          18
Iop_CasCmpNE16         19
Iop_CasCmpNE32         19
Iop_CasCmpNE64         19
Iop_CasCmpNE8          19
Iop_CatEvenLanes16x4  309
Iop_CatEvenLanes16x8  582
Iop_CatEvenLanes32x4  582
Iop_CatEvenLanes8x16  582
Iop_CatEvenLanes8x8   309
Iop_CatOddLanes16x4   308
Iop_CatOddLanes16x8   581
Iop_CatOddLanes32x4   581
Iop_CatOddLanes8x16   581
Iop_CatOddLanes8x8    308
Iop_CipherLV128       636
Iop_CipherSV128       636
Iop_CipherV128        636
Iop_Cls16Sx4          280
Iop_Cls16Sx8          535
Iop_Cls32Sx2          280
Iop_Cls32Sx4          535
Iop_Cls8Sx16          535
Iop_Cls8Sx8           280
Iop_Clz16Sx4          279
Iop_Clz16Sx8          534
Iop_Clz32              25
Iop_Clz32Sx2          279
Iop_Clz32Sx4          534
Iop_Clz64              25
Iop_Clz64x2           281
Iop_Clz8Sx16          534
Iop_Clz8Sx8           279
Iop_CmpD128           387
Iop_CmpD64            386
Iop_CmpEQ16            14
Iop_CmpEQ16x16        618
Iop_CmpEQ16x4         274
Iop_CmpEQ16x8         529
Iop_CmpEQ32            14
Iop_CmpEQ32F0x4       444
Iop_CmpEQ32Fx2        226
Iop_CmpEQ32Fx4        416
Iop_CmpEQ32x2         274
Iop_CmpEQ32x4         529
Iop_CmpEQ32x8         618
Iop_CmpEQ64            14
Iop_CmpEQ64F0x2       458
Iop_CmpEQ64Fx2        451
Iop_CmpEQ64x2         529
Iop_CmpEQ64x4         618
Iop_CmpEQ8             14
Iop_CmpEQ8x16         529
Iop_CmpEQ8x32         618
Iop_CmpEQ8x8          274
Iop_CmpExpD128        390
Iop_CmpExpD64         389
Iop_CmpF128           109
Iop_CmpF32            108
Iop_CmpF64            107
Iop_CmpGE32Fx2        226
Iop_CmpGE32Fx4        417
Iop_CmpGT16Sx16       619
Iop_CmpGT16Sx4        276
Iop_CmpGT16Sx8        530
Iop_CmpGT16Ux4        275
Iop_CmpGT16Ux8        531
Iop_CmpGT32Fx2        226
Iop_CmpGT32Fx4        417
Iop_CmpGT32Sx2        276
Iop_CmpGT32Sx4        530
Iop_CmpGT32Sx8        619
Iop_CmpGT32Ux2        275
Iop_CmpGT32Ux4        531
Iop_CmpGT64Sx2        530
Iop_CmpGT64Sx4        619
Iop_CmpGT64Ux2        531
Iop_CmpGT8Sx16        530
Iop_CmpGT8Sx32        619
Iop_CmpGT8Sx8         276
Iop_CmpGT8Ux16        531
Iop_CmpGT8Ux8         275
Iop_CmpLE32F0x4       444
Iop_CmpLE32Fx4        416
Iop_CmpLE32S           29
Iop_CmpLE32U           31
Iop_CmpLE64F0x2       458
Iop_CmpLE64Fx2        451
Iop_CmpLE64S           29
Iop_CmpLE64U           31
Iop_CmpLT32F0x4       444
Iop_CmpLT32Fx4        416
Iop_CmpLT32S           28
Iop_CmpLT32U           30
Iop_CmpLT64F0x2       458
Iop_CmpLT64Fx2        451
Iop_CmpLT64S           28
Iop_CmpLT64U           30
Iop_CmpNE16            15
Iop_CmpNE32            15
Iop_CmpNE64            15
Iop_CmpNE8             15
Iop_CmpNEZ16           33
Iop_CmpNEZ16x16       615
Iop_CmpNEZ16x2        216
Iop_CmpNEZ16x4        236
Iop_CmpNEZ16x8        479
Iop_CmpNEZ32           33
Iop_CmpNEZ32x2        236
Iop_CmpNEZ32x4        479
Iop_CmpNEZ32x8        615
Iop_CmpNEZ64           33
Iop_CmpNEZ64x2        479
Iop_CmpNEZ64x4        615
Iop_CmpNEZ8            33
Iop_CmpNEZ8x16        479
Iop_CmpNEZ8x32        615
Iop_CmpNEZ8x4         216
Iop_CmpNEZ8x8         236
Iop_CmpORD32S          38
Iop_CmpORD32U          37
Iop_CmpORD64S          38
Iop_CmpORD64U          37
Iop_CmpUN32F0x4       444
Iop_CmpUN32Fx4        416
Iop_CmpUN64F0x2       458
Iop_CmpUN64Fx2        451
Iop_CmpwNEZ32          34
Iop_CmpwNEZ64          34
Iop_Cnt8x16           533
Iop_Cnt8x8            278
Iop_CosF64            169
Iop_Ctz32              26
Iop_Ctz64              26
Iop_D128HItoD64       403
Iop_D128LOtoD64       403
Iop_D128toD64         351
Iop_D128toF128        381
Iop_D128toF32         379
Iop_D128toF64         380
Iop_D128toI32S        360
Iop_D128toI32U        361
Iop_D128toI64S        362
Iop_D128toI64U        363
Iop_D32toD64          339
Iop_D32toF128         375
Iop_D32toF32          373
Iop_D32toF64          374
Iop_D64HLtoD128       403
Iop_D64toD128         341
Iop_D64toD32          350
Iop_D64toF128         378
Iop_D64toF32          376
Iop_D64toF64          377
Iop_D64toI32S         356
Iop_D64toI32U         357
Iop_D64toI64S         358
Iop_D64toI64U         359
Iop_Div32F0x4         442
Iop_Div32Fx4          413
Iop_Div32Fx8          648
Iop_Div64F0x2         456
Iop_Div64Fx2          449
Iop_Div64Fx4          644
Iop_DivD128           333
Iop_DivD64            330
Iop_DivF128           139
Iop_DivF32             95
Iop_DivF64             93
Iop_DivF64r32          97
Iop_DivModS128to64     51
Iop_DivModS64to32      49
Iop_DivModS64to64      52
Iop_DivModU128to64     50
Iop_DivModU64to32      48
Iop_DivS32             41
Iop_DivS32E            47
Iop_DivS64             43
Iop_DivS64E            45
Iop_DivU32             40
Iop_DivU32E            46
Iop_DivU64             42
Iop_DivU64E            44
Iop_DPBtoBCD          404
Iop_Dup16x4           314
Iop_Dup16x8           586
Iop_Dup32x2           314
Iop_Dup32x4           586
Iop_Dup8x16           586
Iop_Dup8x8            314
Iop_Est5FRSqrt        186
Iop_ExpCmpNE16         20
Iop_ExpCmpNE32         20
Iop_ExpCmpNE64         20
Iop_ExpCmpNE8          20
Iop_Extract64         316
Iop_ExtractExpD128    398
Iop_ExtractExpD64     397
Iop_ExtractSigD128    400
Iop_ExtractSigD64     399
Iop_ExtractV128       588
Iop_F128HItoF64       136
Iop_F128LOtoF64       137
Iop_F128toD128        372
Iop_F128toD32         370
Iop_F128toD64         371
Iop_F128toF32         155
Iop_F128toF64         154
Iop_F128toI32S        150
Iop_F128toI32U        152
Iop_F128toI64S        151
Iop_F128toI64U        153
Iop_F16toF32x4        439
Iop_F32toD128         366
Iop_F32toD32          364
Iop_F32toD64          365
Iop_F32toF128         148
Iop_F32toF16x4        439
Iop_F32toF64          129
Iop_F32ToFixed32Sx2_RZ  221
Iop_F32ToFixed32Sx4_RZ  436
Iop_F32ToFixed32Ux2_RZ  221
Iop_F32ToFixed32Ux4_RZ  436
Iop_F32toI32S         122
Iop_F32toI32U         124
Iop_F32toI64S         123
Iop_F32toI64U         125
Iop_F64HLtoF128       135
Iop_F64toD128         369
Iop_F64toD32          367
Iop_F64toD64          368
Iop_F64toF128         149
Iop_F64toF32          130
Iop_F64toI16S         111
Iop_F64toI32S         112
Iop_F64toI32U         115
Iop_F64toI64S         113
Iop_F64toI64U         114
Iop_Fixed32SToF32x2_RN  222
Iop_Fixed32SToF32x4_RN  437
Iop_Fixed32UToF32x2_RN  222
Iop_Fixed32UToF32x4_RN  437
Iop_FtoI32Sx2_RZ      220
Iop_FtoI32Sx4_RZ      432
Iop_FtoI32Ux2_RZ      220
Iop_FtoI32Ux4_RZ      432
Iop_GetElem16x4       311
Iop_GetElem16x8       584
Iop_GetElem32x2       311
Iop_GetElem32x4       584
Iop_GetElem64x2       584
Iop_GetElem8x16       584
Iop_GetElem8x8        311
Iop_GetMSBs8x16       597
Iop_GetMSBs8x8        324
Iop_HAdd16Sx2         204
Iop_HAdd16Ux2         204
Iop_HAdd8Sx4          211
Iop_HAdd8Ux4          211
Iop_HSub16Sx2         205
Iop_HSub16Ux2         205
Iop_HSub8Sx4          212
Iop_HSub8Ux4          212
Iop_I32StoD128        343
Iop_I32StoD64         352
Iop_I32StoF128        144
Iop_I32StoF32         126
Iop_I32StoF64         116
Iop_I32StoFx2         219
Iop_I32StoFx4         431
Iop_I32UtoD128        345
Iop_I32UtoD64         353
Iop_I32UtoF128        146
Iop_I32UtoF32         120
Iop_I32UtoF64         121
Iop_I32UtoFx2         219
Iop_I32UtoFx4         431
Iop_I64StoD128        347
Iop_I64StoD64         354
Iop_I64StoF128        145
Iop_I64StoF32         127
Iop_I64StoF64         117
Iop_I64UtoD128        349
Iop_I64UtoD64         355
Iop_I64UtoF128        147
Iop_I64UtoF32         119
Iop_I64UtoF64         118
Iop_InsertExpD128     402
Iop_InsertExpD64      401
Iop_InterleaveEvenLanes16x4  306
Iop_InterleaveEvenLanes16x8  578
Iop_InterleaveEvenLanes32x4  579
Iop_InterleaveEvenLanes8x16  577
Iop_InterleaveEvenLanes8x8  305
Iop_InterleaveHI16x4  303
Iop_InterleaveHI16x8  572
Iop_InterleaveHI32x2  303
Iop_InterleaveHI32x4  573
Iop_InterleaveHI64x2  573
Iop_InterleaveHI8x16  572
Iop_InterleaveHI8x8   303
Iop_InterleaveLO16x4  304
Iop_InterleaveLO16x8  574
Iop_InterleaveLO32x2  304
Iop_InterleaveLO32x4  575
Iop_InterleaveLO64x2  575
Iop_InterleaveLO8x16  574
Iop_InterleaveLO8x8   304
Iop_InterleaveOddLanes16x4  306
Iop_InterleaveOddLanes16x8  578
Iop_InterleaveOddLanes32x4  579
Iop_InterleaveOddLanes8x16  577
Iop_InterleaveOddLanes8x8  305
Iop_INVALID             2
Iop_LAST              655
Iop_Left16             35
Iop_Left32             35
Iop_Left64             35
Iop_Left8              35
Iop_MAddF32           177
Iop_MAddF64           182
Iop_MAddF64r32        184
Iop_Max16Sx16         623
Iop_Max16Sx4          269
Iop_Max16Sx8          524
Iop_Max16Ux16         624
Iop_Max16Ux4          270
Iop_Max16Ux8          525
Iop_Max32F0x4         443
Iop_Max32Fx2          224
Iop_Max32Fx4          414
Iop_Max32Fx8          653
Iop_Max32Sx2          269
Iop_Max32Sx4          524
Iop_Max32Sx8          623
Iop_Max32U             36
Iop_Max32Ux2          270
Iop_Max32Ux4          525
Iop_Max32Ux8          624
Iop_Max64F0x2         457
Iop_Max64Fx2          450
Iop_Max64Fx4          654
Iop_Max64Sx2          524
Iop_Max64Ux2          525
Iop_Max8Sx16          524
Iop_Max8Sx32          623
Iop_Max8Sx8           269
Iop_Max8Ux16          525
Iop_Max8Ux32          624
Iop_Max8Ux8           270
Iop_Min16Sx16         625
Iop_Min16Sx4          271
Iop_Min16Sx8          526
Iop_Min16Ux16         626
Iop_Min16Ux4          272
Iop_Min16Ux8          527
Iop_Min32F0x4         443
Iop_Min32Fx2          224
Iop_Min32Fx4          414
Iop_Min32Fx8          653
Iop_Min32Sx2          271
Iop_Min32Sx4          526
Iop_Min32Sx8          625
Iop_Min32Ux2          272
Iop_Min32Ux4          527
Iop_Min32Ux8          626
Iop_Min64F0x2         457
Iop_Min64Fx2          450
Iop_Min64Fx4          654
Iop_Min64Sx2          526
Iop_Min64Ux2          527
Iop_Min8Sx16          526
Iop_Min8Sx32          625
Iop_Min8Sx8           271
Iop_Min8Ux16          527
Iop_Min8Ux32          626
Iop_Min8Ux8           272
Iop_MSubF32           177
Iop_MSubF64           182
Iop_MSubF64r32        184
Iop_Mul16               6
Iop_Mul16x16          627
Iop_Mul16x4           257
Iop_Mul16x8           489
Iop_Mul32               6
Iop_Mul32F0x4         442
Iop_Mul32Fx2          258
Iop_Mul32Fx4          413
Iop_Mul32Fx8          647
Iop_Mul32x2           257
Iop_Mul32x4           489
Iop_Mul32x8           627
Iop_Mul64               6
Iop_Mul64F0x2         456
Iop_Mul64Fx2          449
Iop_Mul64Fx4          643
Iop_Mul8                6
Iop_Mul8x16           489
Iop_Mul8x8            257
Iop_MulD128           333
Iop_MulD64            330
Iop_MulF128           139
Iop_MulF32             95
Iop_MulF64             93
Iop_MulF64r32          97
Iop_MulHi16Sx16       628
Iop_MulHi16Sx4        260
Iop_MulHi16Sx8        491
Iop_MulHi16Ux16       628
Iop_MulHi16Ux4        259
Iop_MulHi16Ux8        490
Iop_MulHi32Sx4        491
Iop_MulHi32Ux4        490
Iop_Mull16Sx4         497
Iop_Mull16Ux4         497
Iop_Mull32Sx2         498
Iop_Mull32Ux2         498
Iop_Mull8Sx8          496
Iop_Mull8Ux8          496
Iop_MullEven16Sx8     494
Iop_MullEven16Ux8     493
Iop_MullEven32Sx4     494
Iop_MullEven32Ux4     493
Iop_MullEven8Sx16     494
Iop_MullEven8Ux16     493
Iop_MullS16            22
Iop_MullS32            22
Iop_MullS64            22
Iop_MullS8             22
Iop_MullU16            23
Iop_MullU32            23
Iop_MullU64            23
Iop_MullU8             23
Iop_NarrowBin16to8x16  558
Iop_NarrowBin16to8x8  301
Iop_NarrowBin32to16x4  301
Iop_NarrowBin32to16x8  558
Iop_NarrowBin64to32x4  560
Iop_NarrowUn16to8x8   562
Iop_NarrowUn32to16x4  562
Iop_NarrowUn64to32x2  562
Iop_NCipherLV128      637
Iop_NCipherV128       637
Iop_Neg32Fx2          233
Iop_Neg32Fx4          424
Iop_NegF128           141
Iop_NegF32            100
Iop_NegF64             99
Iop_Not1               80
Iop_Not16              17
Iop_Not32              17
Iop_Not64              17
Iop_Not8               17
Iop_NotV128           474
Iop_NotV256           613
Iop_Or16                7
Iop_Or32                7
Iop_Or64                7
Iop_Or8                 7
Iop_OrV128            475
Iop_OrV256            611
Iop_Perm32x4          595
Iop_Perm32x8          634
Iop_Perm8x16          594
Iop_Perm8x8           322
Iop_PolynomialMul8x16  504
Iop_PolynomialMul8x8  261
Iop_PolynomialMulAdd16x8  507
Iop_PolynomialMulAdd32x4  508
Iop_PolynomialMulAdd64x2  508
Iop_PolynomialMulAdd8x16  507
Iop_PolynomialMull8x8  505
Iop_PRem1C3210F64     164
Iop_PRem1F64          163
Iop_PRemC3210F64      162
Iop_PRemF64           161
Iop_PwAdd16x4         242
Iop_PwAdd16x8         510
Iop_PwAdd32Fx2        511
Iop_PwAdd32x2         242
Iop_PwAdd32x4         510
Iop_PwAdd8x16         510
Iop_PwAdd8x8          242
Iop_PwAddL16Sx4       249
Iop_PwAddL16Sx8       514
Iop_PwAddL16Ux4       248
Iop_PwAddL16Ux8       513
Iop_PwAddL32Sx2       249
Iop_PwAddL32Sx4       514
Iop_PwAddL32Ux2       248
Iop_PwAddL32Ux4       513
Iop_PwAddL8Sx16       514
Iop_PwAddL8Sx8        249
Iop_PwAddL8Ux16       513
Iop_PwAddL8Ux8        248
Iop_PwBitMtxXpose64x2  517
Iop_PwMax16Sx4        243
Iop_PwMax16Ux4        244
Iop_PwMax32Fx2        225
Iop_PwMax32Fx4        421
Iop_PwMax32Sx2        243
Iop_PwMax32Ux2        244
Iop_PwMax8Sx8         243
Iop_PwMax8Ux8         244
Iop_PwMin16Sx4        245
Iop_PwMin16Ux4        246
Iop_PwMin32Fx2        225
Iop_PwMin32Fx4        421
Iop_PwMin32Sx2        245
Iop_PwMin32Ux2        246
Iop_PwMin8Sx8         245
Iop_PwMin8Ux8         246
Iop_QAdd16Sx16        630
Iop_QAdd16Sx2         201
Iop_QAdd16Sx4         240
Iop_QAdd16Sx8         483
Iop_QAdd16Ux16        629
Iop_QAdd16Ux2         201
Iop_QAdd16Ux4         239
Iop_QAdd16Ux8         482
Iop_QAdd32S           197
Iop_QAdd32Sx2         240
Iop_QAdd32Sx4         483
Iop_QAdd32Ux2         239
Iop_QAdd32Ux4         482
Iop_QAdd64Sx1         240
Iop_QAdd64Sx2         483
Iop_QAdd64Ux1         239
Iop_QAdd64Ux2         482
Iop_QAdd8Sx16         483
Iop_QAdd8Sx32         630
Iop_QAdd8Sx4          208
Iop_QAdd8Sx8          240
Iop_QAdd8Ux16         482
Iop_QAdd8Ux32         629
Iop_QAdd8Ux4          208
Iop_QAdd8Ux8          239
Iop_QDMulHi16Sx4      263
Iop_QDMulHi16Sx8      500
Iop_QDMulHi32Sx2      263
Iop_QDMulHi32Sx4      500
Iop_QDMulLong16Sx4    503
Iop_QDMulLong32Sx2    503
Iop_QFtoI32Sx4_RZ     433
Iop_QFtoI32Ux4_RZ     433
Iop_QNarrowBin16Sto8Sx16  556
Iop_QNarrowBin16Sto8Sx8  300
Iop_QNarrowBin16Sto8Ux16  555
Iop_QNarrowBin16Sto8Ux8  299
Iop_QNarrowBin16Uto8Ux16  557
Iop_QNarrowBin32Sto16Sx4  300
Iop_QNarrowBin32Sto16Sx8  556
Iop_QNarrowBin32Sto16Ux8  555
Iop_QNarrowBin32Uto16Ux8  557
Iop_QNarrowBin64Sto32Sx4  559
Iop_QNarrowBin64Uto32Ux4  559
Iop_QNarrowUn16Sto8Sx8  564
Iop_QNarrowUn16Sto8Ux8  565
Iop_QNarrowUn16Uto8Ux8  567
Iop_QNarrowUn32Sto16Sx4  564
Iop_QNarrowUn32Sto16Ux4  565
Iop_QNarrowUn32Uto16Ux4  567
Iop_QNarrowUn64Sto32Sx2  564
Iop_QNarrowUn64Sto32Ux2  565
Iop_QNarrowUn64Uto32Ux2  567
Iop_QRDMulHi16Sx4     264
Iop_QRDMulHi16Sx8     501
Iop_QRDMulHi32Sx2     264
Iop_QRDMulHi32Sx4     501
Iop_QSal16x4          293
Iop_QSal16x8          548
Iop_QSal32x2          293
Iop_QSal32x4          548
Iop_QSal64x1          293
Iop_QSal64x2          548
Iop_QSal8x16          548
Iop_QSal8x8           293
Iop_QSalN16x4         297
Iop_QSalN16x8         552
Iop_QSalN32x2         297
Iop_QSalN32x4         552
Iop_QSalN64x1         297
Iop_QSalN64x2         552
Iop_QSalN8x16         552
Iop_QSalN8x8          297
Iop_QShl16x4          292
Iop_QShl16x8          547
Iop_QShl32x2          292
Iop_QShl32x4          547
Iop_QShl64x1          292
Iop_QShl64x2          547
Iop_QShl8x16          547
Iop_QShl8x8           292
Iop_QShlN16Sx4        295
Iop_QShlN16Sx8        550
Iop_QShlN16x4         296
Iop_QShlN16x8         551
Iop_QShlN32Sx2        295
Iop_QShlN32Sx4        550
Iop_QShlN32x2         296
Iop_QShlN32x4         551
Iop_QShlN64Sx1        295
Iop_QShlN64Sx2        550
Iop_QShlN64x1         296
Iop_QShlN64x2         551
Iop_QShlN8Sx16        550
Iop_QShlN8Sx8         295
Iop_QShlN8x16         551
Iop_QShlN8x8          296
Iop_QSub16Sx16        632
Iop_QSub16Sx2         202
Iop_QSub16Sx4         253
Iop_QSub16Sx8         487
Iop_QSub16Ux16        631
Iop_QSub16Ux2         202
Iop_QSub16Ux4         252
Iop_QSub16Ux8         486
Iop_QSub32S           198
Iop_QSub32Sx2         253
Iop_QSub32Sx4         487
Iop_QSub32Ux2         252
Iop_QSub32Ux4         486
Iop_QSub64Sx1         253
Iop_QSub64Sx2         487
Iop_QSub64Ux1         252
Iop_QSub64Ux2         486
Iop_QSub8Sx16         487
Iop_QSub8Sx32         632
Iop_QSub8Sx4          209
Iop_QSub8Sx8          253
Iop_QSub8Ux16         486
Iop_QSub8Ux32         631
Iop_QSub8Ux4          209
Iop_QSub8Ux8          252
Iop_QuantizeD128      393
Iop_QuantizeD64       392
Iop_Recip32F0x4       446
Iop_Recip32Fx2        228
Iop_Recip32Fx4        426
Iop_Recip32Fx8        652
Iop_Recip32x2         326
Iop_Recip32x4         599
Iop_Recip64F0x2       460
Iop_Recip64Fx2        453
Iop_Recps32Fx2        229
Iop_Recps32Fx4        427
Iop_ReinterpD64asI64  409
Iop_ReinterpF32asI32  133
Iop_ReinterpF64asI64  132
Iop_ReinterpI32asF32  133
Iop_ReinterpI64asD64  408
Iop_ReinterpI64asF64  132
Iop_Reverse16_8x16    590
Iop_Reverse16_8x8     318
Iop_Reverse32_16x4    319
Iop_Reverse32_16x8    591
Iop_Reverse32_8x16    591
Iop_Reverse32_8x8     319
Iop_Reverse64_16x4    320
Iop_Reverse64_16x8    592
Iop_Reverse64_32x2    320
Iop_Reverse64_32x4    592
Iop_Reverse64_8x16    592
Iop_Reverse64_8x8     320
Iop_Rol16x8           545
Iop_Rol32x4           545
Iop_Rol64x2           545
Iop_Rol8x16           545
Iop_RoundD128toInt    384
Iop_RoundD64toInt     383
Iop_RoundF32toInt     173
Iop_RoundF32x4_RM     434
Iop_RoundF32x4_RN     435
Iop_RoundF32x4_RP     434
Iop_RoundF32x4_RZ     435
Iop_RoundF64toF32     194
Iop_RoundF64toF64_NEAREST  187
Iop_RoundF64toF64_NegINF  188
Iop_RoundF64toF64_PosINF  189
Iop_RoundF64toF64_ZERO  190
Iop_RoundF64toInt     172
Iop_RSqrt32F0x4       446
Iop_RSqrt32Fx4        423
Iop_RSqrt32Fx8        651
Iop_RSqrt64F0x2       460
Iop_RSqrt64Fx2        453
Iop_Rsqrte32Fx2       230
Iop_Rsqrte32Fx4       428
Iop_Rsqrte32x2        326
Iop_Rsqrte32x4        599
Iop_Rsqrts32Fx2       231
Iop_Rsqrts32Fx4       429
Iop_Sad8Ux4           214
Iop_Sal16x4           286
Iop_Sal16x8           544
Iop_Sal32x2           286
Iop_Sal32x4           544
Iop_Sal64x1           286
Iop_Sal64x2           544
Iop_Sal8x16           544
Iop_Sal8x8            286
Iop_Sar16              12
Iop_Sar16x4           285
Iop_Sar16x8           543
Iop_Sar32              12
Iop_Sar32x2           285
Iop_Sar32x4           543
Iop_Sar64              12
Iop_Sar64x2           543
Iop_Sar8               12
Iop_Sar8x16           543
Iop_Sar8x8            285
Iop_SarN16x16         622
Iop_SarN16x4          290
Iop_SarN16x8          539
Iop_SarN32x2          290
Iop_SarN32x4          539
Iop_SarN32x8          622
Iop_SarN64x2          539
Iop_SarN8x16          539
Iop_SarN8x8           290
Iop_ScaleF64          165
Iop_SetElem16x4       312
Iop_SetElem32x2       312
Iop_SetElem8x8        312
Iop_SetV128lo32       471
Iop_SetV128lo64       467
Iop_SHA256            639
Iop_SHA512            639
Iop_Shl16              10
Iop_Shl16x4           283
Iop_Shl16x8           541
Iop_Shl32              10
Iop_Shl32x2           283
Iop_Shl32x4           541
Iop_Shl64              10
Iop_Shl64x2           541
Iop_Shl8               10
Iop_Shl8x16           541
Iop_Shl8x8            283
Iop_ShlD128           337
Iop_ShlD64            335
Iop_ShlN16x16         620
Iop_ShlN16x4          288
Iop_ShlN16x8          537
Iop_ShlN32x2          288
Iop_ShlN32x4          537
Iop_ShlN32x8          620
Iop_ShlN64x2          537
Iop_ShlN64x4          620
Iop_ShlN8x16          537
Iop_ShlN8x8           288
Iop_ShlV128           477
Iop_Shr16              11
Iop_Shr16x4           284
Iop_Shr16x8           542
Iop_Shr32              11
Iop_Shr32x2           284
Iop_Shr32x4           542
Iop_Shr64              11
Iop_Shr64x2           542
Iop_Shr8               11
Iop_Shr8x16           542
Iop_Shr8x8            284
Iop_ShrD128           337
Iop_ShrD64            335
Iop_ShrN16x16         621
Iop_ShrN16x4          289
Iop_ShrN16x8          538
Iop_ShrN32x2          289
Iop_ShrN32x4          538
Iop_ShrN32x8          621
Iop_ShrN64x2          538
Iop_ShrN64x4          621
Iop_ShrN8x16          538
Iop_ShrN8x8           289
Iop_ShrV128           477
Iop_SignificanceRoundD128  395
Iop_SignificanceRoundD64  394
Iop_SinF64            168
Iop_Sqrt32F0x4        446
Iop_Sqrt32Fx4         423
Iop_Sqrt32Fx8         649
Iop_Sqrt64F0x2        460
Iop_Sqrt64Fx2         453
Iop_Sqrt64Fx4         650
Iop_SqrtF128          143
Iop_SqrtF32           105
Iop_SqrtF64           103
Iop_Sub16               4
Iop_Sub16x16          617
Iop_Sub16x2           200
Iop_Sub16x4           251
Iop_Sub16x8           485
Iop_Sub32               4
Iop_Sub32F0x4         442
Iop_Sub32Fx2          415
Iop_Sub32Fx4          413
Iop_Sub32Fx8          646
Iop_Sub32x2           251
Iop_Sub32x4           485
Iop_Sub32x8           617
Iop_Sub64               4
Iop_Sub64F0x2         456
Iop_Sub64Fx2          449
Iop_Sub64Fx4          642
Iop_Sub64x2           485
Iop_Sub64x4           617
Iop_Sub8                4
Iop_Sub8x16           485
Iop_Sub8x32           617
Iop_Sub8x4            207
Iop_Sub8x8            251
Iop_SubD128           333
Iop_SubD64            330
Iop_SubF128           139
Iop_SubF32             95
Iop_SubF64             93
Iop_SubF64r32          97
Iop_TanF64            170
Iop_TruncF64asF32     192
Iop_V128HIto64        464
Iop_V128HLtoV256      609
Iop_V128to32          470
Iop_V128to64          463
Iop_V256to64_0        602
Iop_V256to64_1        603
Iop_V256to64_2        604
Iop_V256to64_3        605
Iop_V256toV128_0      607
Iop_V256toV128_1      608
Iop_Widen16Sto32x4    570
Iop_Widen16Uto32x4    569
Iop_Widen32Sto64x2    570
Iop_Widen32Uto64x2    569
Iop_Widen8Sto16x8     570
Iop_Widen8Uto16x8     569
Iop_Xor16               9
Iop_Xor32               9
Iop_Xor64               9
Iop_Xor8                9
Iop_XorV128           475
Iop_XorV256           612
Iop_Yl2xF64           159
Iop_Yl2xp1F64         160
IROp                  656
typedef                 1
